com.google.cloud.dataflow.sdk.transforms

## Interface DoFnWithContext.ExtraContextFactory<InputT,OutputT>

Enclosing class:
  DoFnWithContext<InputT,OutputT>

    public static interface DoFnWithContext.ExtraContextFactory<InputT,OutputT>

Interface for runner implementors to provide implementations of extra context information.

The methods on this interface are called by `DoFnReflector` before invoking an annotated `DoFnWithContext.StartBundle`, `DoFnWithContext.ProcessElement` or `DoFnWithContext.FinishBundle` method that has indicated it needs the given extra context.

In the case of `DoFnWithContext.ProcessElement` it is called once per invocation of `DoFnWithContext.ProcessElement`.

### Method Summary

All Methods Instance Methods Abstract Methods
`BoundedWindow` `window()` Construct the `BoundedWindow` to use within a `DoFnWithContext` that needs it.
`com.google.cloud.dataflow.sdk.util.WindowingInternals<InputT,OutputT>` `windowingInternals()` Construct the `WindowingInternals` to use within a `DoFnWithContext` that needs it.

### Method Detail

#### window

    BoundedWindow window()

Construct the `BoundedWindow` to use within a `DoFnWithContext` that needs it. This is called if the `DoFnWithContext.ProcessElement` method has a parameter of type `BoundedWindow`.

Returns:
  `BoundedWindow` of the element currently being processed.

#### windowingInternals

    com.google.cloud.dataflow.sdk.util.WindowingInternals<InputT,OutputT> windowingInternals()

Construct the `WindowingInternals` to use within a `DoFnWithContext` that needs it. This is called if the `DoFnWithContext.ProcessElement` method has a parameter of type `WindowingInternals`.